/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.24 from the
 * contents of Event.xs. Do not edit this file, edit Event.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Event.xs"
/* -*- C -*- sometimes */

#define MIN_PERL_DEFINE 1

#ifdef __cplusplus
extern "C" {
#endif

#include <EXTERN.h>
#include <perl.h>
#include <XSUB.h>

#ifdef __cplusplus
}
#endif

#include "ppport.h"

/* This is unfortunately necessary for the 5.005_0x series. */
#if PERL_REVISION == 5 && PERL_VERSION <= 5 && PERL_SUBVERSION < 53
#  define PL_vtbl_uvar vtbl_uvar
#  define PL_sig_name sig_name
#  define whichsig Perl_whichsig   /* ? */
#endif

/* lexical warnings -- waiting for appropriate magic from
   paul.marquess@bt.com */
#if 0
static void Event_warn(const char* pat, ...) {
    dTHX;
    va_list args;
    va_start(args, pat);
    if (!ckWARN_d(WARN_ALL))
	return;
    Perl_vwarner(aTHX_ WARN_ALL, pat, &args);
    va_end(args);
}

#  undef warn
#  define warn Event_warn
#endif

#if 1
#ifdef warn
#  undef warn
#endif
#define warn Event_warn

static void Event_warn(const char* pat, ...) {
    STRLEN n_a;
    dSP;
    SV *msg;
    va_list args;
    /* perl_require_pv("Carp.pm");     Couldn't possibly be unloaded.*/
    va_start(args, pat);
    msg = sv_newmortal();
    sv_vsetpvfn(msg, pat, strlen(pat), &args, Null(SV**), 0, 0);
    va_end(args);
    SvREADONLY_on(msg);
    PUSHMARK(SP);
    XPUSHs(msg);
    PUTBACK;
    perl_call_pv("Carp::carp", G_DISCARD);
}
#endif

#ifdef croak
#  undef croak
#endif
#define croak Event_croak

static void Event_croak(const char* pat, ...) {
    STRLEN n_a;
    dSP;
    SV *msg;
    va_list args;
    /* perl_require_pv("Carp.pm");     Couldn't possibly be unloaded.*/
    va_start(args, pat);
    msg = sv_newmortal();
    sv_vsetpvfn(msg, pat, strlen(pat), &args, Null(SV**), 0, 0);
    va_end(args);
    SvREADONLY_on(msg);
    PUSHMARK(SP);
    XPUSHs(msg);
    PUTBACK;
    perl_call_pv("Carp::croak", G_DISCARD);
    PerlIO_puts(PerlIO_stderr(), "panic: Carp::croak failed\n");
    (void)PerlIO_flush(PerlIO_stderr());
    my_failure_exit();
}

#ifdef WIN32
#   include <fcntl.h>
#endif

#if defined(HAS_POLL)
# include <poll.h>

/*
	Many operating systems claim to support poll yet they
	actually emulate it with select.  c/unix.c supports
	either poll or select but it doesn't know which one to
	use.  Here we try to detect if we have a native poll
	implementation.  If we do, we use it.  Otherwise,
	select is assumed.
*/

# ifndef POLLOUT
#  undef HAS_POLL
# endif
# ifndef POLLWRNORM
#  undef HAS_POLL
# endif
# ifndef POLLWRBAND
#  undef HAS_POLL
# endif
#endif

/* Is time() portable everywhere?  Hope so!  XXX */

static NV fallback_NVtime()
{ return time(0); }

#include "Event.h"

/* The following is for very simplistic memory leak detection. */

#define MAX_MEMORYCOUNT 20
static int MemoryCount[MAX_MEMORYCOUNT];
static void dbg_count_memory(int id, int cnt) {
    assert(id >= 0 && id < MAX_MEMORYCOUNT);
    MemoryCount[id] += cnt;
}

#if EVENT_MEMORY_DEBUG
#  define EvNew(id, ptr, size, type) dbg_count_memory(id,1); New(0,ptr,size,type)
#  define EvFree(id, ptr) STMT_START { dbg_count_memory(id,-1); safefree(ptr); } STMT_END
#else
#  define EvNew(x, ptr, size, type) New(0,ptr,size,type)
#  define EvFree(id, ptr) safefree(ptr)
#endif

static int LoopLevel, ExitLevel;
static int ActiveWatchers=0; /* includes WaACTIVE + queued events */
static int WarnCounter=16; /*XXX nuke */
static SV *DebugLevel;
static SV *Eval;
static pe_event_stats_vtbl Estat;

/* IntervalEpsilon should be equal to the clock's sleep resolution
   (poll or select) times two.  It probably needs to be bigger if you turn
   on lots of debugging?  Can determine this dynamically? XXX */
static NV IntervalEpsilon = 0.0002;
static int TimeoutTooEarly=0;

static struct EventAPI api;
#define NVtime() (*api.NVtime)()

static int pe_sys_fileno(SV *sv, char *context);

static void queueEvent(pe_event *ev);
static void dequeEvent(pe_event *ev);

static void pe_watcher_cancel(pe_watcher *ev);
static void pe_watcher_suspend(pe_watcher *ev);
static void pe_watcher_resume(pe_watcher *ev);
static void pe_watcher_now(pe_watcher *ev);
static void pe_watcher_start(pe_watcher *ev, int repeat);
static void pe_watcher_stop(pe_watcher *ev, int cancel_events);
static char*pe_watcher_on(pe_watcher *wa, int repeat);
static void pe_watcher_off(pe_watcher *wa);

/* The newHVhv in perl seems to mysteriously break in some cases.  Here
   is a simple and safe (but maybe slow) implementation. */

#ifdef newHVhv
# undef newHVhv
#endif
#define newHVhv event_newHVhv

static HV *event_newHVhv(HV *ohv) {
    register HV *hv = newHV();
    register HE *entry;
    hv_iterinit(ohv);		/* NOTE: this resets the iterator */
    while (entry = hv_iternext(ohv)) {
	hv_store(hv, HeKEY(entry), HeKLEN(entry), 
		SvREFCNT_inc(HeVAL(entry)), HeHASH(entry));
    }
    return hv;
}

static void pe_watcher_STORE_FALLBACK(pe_watcher *wa, SV *svkey, SV *nval)
{
    if (!wa->FALLBACK)
	wa->FALLBACK = newHV();
    hv_store_ent(wa->FALLBACK, svkey, SvREFCNT_inc(nval), 0);
}

/***************** STATS */
static int StatsInstalled=0;
static void pe_install_stats(pe_event_stats_vtbl *esvtbl) {
    ++StatsInstalled;
    Copy(esvtbl, &Estat, 1, pe_event_stats_vtbl);
    Estat.on=0;
}
static void pe_collect_stats(int yes) {
    if (!StatsInstalled)
	croak("collect_stats: no event statistics are available");
    Estat.on = yes;
}

#ifdef HAS_GETTIMEOFDAY
NV null_loops_per_second(int sec)
{
	/*
	  This should be more realistic.  It is used to normalize
	  the benchmark against some theoretical perfect event loop.
	*/
	struct timeval start_tm, done_tm;
	NV elapse;
	unsigned count=0;
	int fds[2];
	if (pipe(fds) != 0) croak("pipe");
	gettimeofday(&start_tm, 0);
	do {
#ifdef HAS_POLL
	  struct pollfd map[2];
	  Zero(map, 2, struct pollfd);
	  map[0].fd = fds[0];
	  map[0].events = POLLIN | POLLOUT;
	  map[0].revents = 0;
	  map[1].fd = fds[1];
	  map[1].events = POLLIN | POLLOUT;
	  map[1].revents = 0;
	  poll(map, 2, 0);
#elif defined(HAS_SELECT)
	  struct timeval null;
	  fd_set rfds, wfds, efds;
	  FD_ZERO(&rfds);
	  FD_ZERO(&wfds);
	  FD_ZERO(&efds);
	  FD_SET(fds[0], &rfds);
	  FD_SET(fds[0], &wfds);
	  FD_SET(fds[1], &rfds);
	  FD_SET(fds[1], &wfds);
	  null.tv_sec = 0;
	  null.tv_usec = 0;
	  select(3,&rfds,&wfds,&efds,&null);
#else
#  error
#endif
	  ++count;
	  gettimeofday(&done_tm, 0);
	  elapse = (done_tm.tv_sec - start_tm.tv_sec +
		    (done_tm.tv_usec - start_tm.tv_usec) / 1000000);
	} while(elapse < sec);
	close(fds[0]);
	close(fds[1]);
return count/sec;
}
#else /* !HAS_GETTIMEOFDAY */
NV null_loops_per_second(int sec)
{ croak("sorry, gettimeofday is not available"); }
#endif


#include "typemap.c"
#include "timeable.c"
#include "hook.c"
#include "ev.c"
#include "watcher.c"
#include "idle.c"
#include "timer.c"
#include "io.c"
#include "unix.c"
#include "var.c"
#include "signal.c"
#include "tied.c"
#include "group.c"
#include "generic.c"
#include "queue.c"

#line 293 "Event.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)    S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage        S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 435 "Event.c"

XS_EUPXS(XS_Event__add_hook); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__add_hook)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "type, code");
    {
	char *	type = (char *)SvPV_nolen(ST(0))
;
	SV *	code = ST(1)
;
#line 349 "Event.xs"
	pe_add_hook(type, 1, code, 0);
	/* would be nice to return new pe_qcallback* XXX */
#line 451 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__timeout_too_early); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__timeout_too_early)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 355 "Event.xs"
	RETVAL = TimeoutTooEarly;
	TimeoutTooEarly=0;
#line 469 "Event.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event__memory_counters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__memory_counters)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 363 "Event.xs"
{
#ifdef EVENT_MEMORY_DEBUG
    int xx;
    for (xx=0; xx < MAX_MEMORYCOUNT; xx++)
	XPUSHs(sv_2mortal(newSViv(MemoryCount[xx])));
#endif
}
#line 493 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__incr_looplevel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__incr_looplevel)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 374 "Event.xs"
     ++LoopLevel;
     ++ExitLevel;
#line 512 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__decr_looplevel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__decr_looplevel)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 380 "Event.xs"
     --LoopLevel;
#line 530 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event_unloop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_unloop)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 385 "Event.xs"
     pe_unloop(items? ST(0) : &PL_sv_undef);
#line 545 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event_unloop_all); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_unloop_all)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 390 "Event.xs"
     pe_unloop_all(items? ST(0) : &PL_sv_undef);
#line 559 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event_cache_time_api); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_cache_time_api)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	bool	RETVAL;
#line 395 "Event.xs"
	SV **svp = hv_fetch(PL_modglobal, "Time::NVtime", 12, 0);
	if (!svp || !*svp || !SvIOK(*svp))
	    XSRETURN_NO;
	api.NVtime = INT2PTR(NV(*)(), SvIV(*svp));
	XSRETURN_YES;
#line 579 "Event.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event_time); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_time)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	NV	RETVAL;
	dXSTARG;
#line 405 "Event.xs"
	RETVAL = NVtime();
#line 596 "Event.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event_sleep); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_sleep)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tm");
    {
	NV	tm = (NV)SvNV(ST(0))
;
#line 414 "Event.xs"
	pe_sys_sleep(tm);
#line 614 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event_null_loops_per_second); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_null_loops_per_second)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sec");
    {
	int	sec = (int)SvIV(ST(0))
;
	NV	RETVAL;
	dXSTARG;

	RETVAL = null_loops_per_second(sec);
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event_all_watchers); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_all_watchers)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 424 "Event.xs"
	pe_watcher *ev;
	if (!AllWatchers.next)
	  return;
	ev = (pe_watcher*) AllWatchers.next->self;
	while (ev) {
	  XPUSHs(watcher_2sv(ev));
	  ev = (pe_watcher*) ev->all.next->self;
	}
#line 657 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event_all_idle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_all_idle)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 437 "Event.xs"
	pe_watcher *ev;
	if (!Idle.prev)
	  return;
	ev = (pe_watcher*) Idle.prev->self;
	while (ev) {
	  XPUSHs(watcher_2sv(ev));
	  ev = (pe_watcher*) ((pe_idle*)ev)->iring.prev->self;
	}
#line 682 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event_all_running); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_all_running)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 450 "Event.xs"
	int fx;
	for (fx = CurCBFrame; fx >= 0; fx--) {
	  pe_watcher *ev = (CBFrame + fx)->ev->up; /* XXX */
	  XPUSHs(watcher_2sv(ev));
	  if (GIMME_V != G_ARRAY)
	    break;
	}
#line 706 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event_queue); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_queue)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 462 "Event.xs"
	pe_watcher *wa;
	pe_event *ev;
#line 724 "Event.c"
#line 465 "Event.xs"
	wa = (pe_watcher*) sv_2watcher(ST(0));
	if (items == 1) {
	    ev = (*wa->vtbl->new_event)(wa);
	    ++ev->hits;
	}
	else if (items == 2) {
	  if (SvNIOK(ST(1))) {
	    ev = (*wa->vtbl->new_event)(wa);
	    ev->hits += SvIV(ST(1));
	  }
	  else {
	    ev = (pe_event*) sv_2event(ST(1));
	    if (ev->up != wa)
	      croak("queue: event doesn't match watcher");
	  }
	}
	queueEvent(ev);
#line 743 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event_one_event); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_one_event)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 487 "Event.xs"
	NV maxtm = 60;
	if (items == 1) maxtm = SvNV(ST(0));
	RETVAL = safe_one_event(maxtm);
#line 762 "Event.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event__loop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__loop)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 496 "Event.xs"
	pe_check_recovery();
	pe_reentry();
        if (!ActiveWatchers)
          warn("Event: loop without active watchers");
	while (ExitLevel >= LoopLevel && ActiveWatchers) {
	  ENTER;
	  SAVETMPS;
	  one_event(60);
	  FREETMPS;
	  LEAVE;
	}
	LEAVE; /* reentry */
#line 789 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event_queue_pending); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_queue_pending)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 512 "Event.xs"
	pe_queue_pending();
#line 804 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__empty_queue); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__empty_queue)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "prio");
    {
	int	prio = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 518 "Event.xs"
	pe_check_recovery();
	pe_reentry();
	while (pe_empty_queue(prio));
	LEAVE; /* reentry */
#line 826 "Event.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event_queue_time); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_queue_time)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "prio");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	prio = (int)SvIV(ST(0))
;
#line 527 "Event.xs"
	NV max=0;
	int xx;
	if (prio < 0 || prio >= PE_QUEUES)
	  croak("queue_time(%d) out of domain [0..%d]",
		prio, PE_QUEUES-1);
	for (xx=0; xx <= prio; xx++)
	  if (max < QueueTime[xx]) max = QueueTime[xx];
	XPUSHs(max? sv_2mortal(newSVnv(max)) : &PL_sv_undef);
#line 852 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Event__Io_got); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Event__Io_got)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_event *	THIS = (pe_event *) sv_2event(ST(0))
;
#line 542 "Event.xs"
	XPUSHs(sv_2mortal(events_mask_2sv(((pe_ioevent*)THIS)->got)));
#line 872 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Event__Dataful_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Event__Dataful_data)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_event *	THIS = (pe_event *) sv_2event(ST(0))
;
#line 549 "Event.xs"
	XPUSHs(((pe_datafulevent*)THIS)->data);
#line 892 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Event_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Event_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ref");
    {
	SV *	ref = ST(0)
;
#line 557 "Event.xs"
{
	pe_event *THIS = (pe_event*) sv_2event(ref);
	if (WaDEBUGx(THIS) >= 3) {
	    STRLEN n_a;
	    warn("Event=0x%x '%s' DESTROY SV=0x%x",
		 THIS, SvPV(THIS->up->desc, n_a),
		 THIS->mysv? SvRV(THIS->mysv) : 0);
	}
	(*THIS->vtbl->dtor)(THIS);
}
#line 919 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Event_mom); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Event_mom)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_event *	THIS = (pe_event *) sv_2event(ST(0))
;
#line 571 "Event.xs"
	if (--WarnCounter >= 0) warn("'mom' renamed to 'w'");
	XPUSHs(watcher_2sv(THIS->up));
#line 939 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Event_w); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Event_w)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_event *	THIS = (pe_event *) sv_2event(ST(0))
;
#line 577 "Event.xs"
	XPUSHs(watcher_2sv(THIS->up));
#line 959 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Event_hits); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Event_hits)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_event *	THIS = (pe_event *) sv_2event(ST(0))
;
#line 582 "Event.xs"
	XPUSHs(sv_2mortal(newSViv(THIS->hits)));
#line 979 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Event_prio); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Event_prio)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_event *	THIS = (pe_event *) sv_2event(ST(0))
;
#line 587 "Event.xs"
	XPUSHs(sv_2mortal(newSViv(THIS->prio)));
#line 999 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ref");
    {
	SV *	ref = ST(0)
;
#line 595 "Event.xs"
{
	pe_watcher *THIS = (pe_watcher*) sv_2watcher(ref);
	assert(THIS);
	if (THIS->mysv) {
	    THIS->mysv=0;
	    if (WaCANDESTROY(THIS)) /*mysv*/
		(*THIS->vtbl->dtor)(THIS);
	}
}
#line 1025 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Watcher_pending); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_pending)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 608 "Event.xs"
{
    if (GIMME_V == G_ARRAY) {
	pe_event *ev = (pe_event *) THIS->events.prev->self;
	while (ev) {
	    XPUSHs(event_2sv(ev));
	    ev = (pe_event*) ev->peer.prev->self;
	}
    } else {
	XPUSHs(THIS->events.next->self? &PL_sv_yes : &PL_sv_no);
    }
}
#line 1054 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_again); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_again)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 623 "Event.xs"
	pe_watcher_start(THIS, 1);
#line 1072 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Watcher_start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_start)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 628 "Event.xs"
	pe_watcher_start(THIS, 0);
#line 1089 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Watcher_suspend); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_suspend)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 633 "Event.xs"
	if (items == 2) {
	    if (sv_true(ST(1)))
		pe_watcher_suspend(THIS);
	    else
		pe_watcher_resume(THIS);
	} else {
	    warn("Ambiguous use of suspend"); /*XXX*/
	    pe_watcher_suspend(THIS);
	    XSRETURN_YES;
	}
#line 1115 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Watcher_resume); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_resume)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 647 "Event.xs"
	warn("Please use $w->suspend(0) instead of resume"); /* DEPRECATED */
	pe_watcher_resume(THIS);
#line 1133 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Watcher_stop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_stop)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 653 "Event.xs"
	pe_watcher_stop(THIS, 1);
#line 1150 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Watcher_cancel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_cancel)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 658 "Event.xs"
	pe_watcher_cancel(THIS);
#line 1167 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Watcher_now); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_now)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 663 "Event.xs"
	pe_watcher_now(THIS);
#line 1184 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Watcher_use_keys); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_use_keys)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 668 "Event.xs"
#line 1200 "Event.c"
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 669 "Event.xs"
	warn("use_keys is deprecated");
#line 1205 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_is_running); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_is_running)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 674 "Event.xs"
	XPUSHs(sv_2mortal(newSViv(THIS->running)));
#line 1225 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_is_active); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_is_active)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 679 "Event.xs"
	PUTBACK;
	XPUSHs(boolSV(WaACTIVE(THIS)));
#line 1246 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_is_suspended); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_is_suspended)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 685 "Event.xs"
	PUTBACK;
	XPUSHs(boolSV(WaSUSPEND(THIS)));
#line 1267 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_is_cancelled); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_is_cancelled)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 691 "Event.xs"
	PUTBACK;
	XPUSHs(boolSV(WaCANCELLED(THIS)));
#line 1288 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_cb); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_cb)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 697 "Event.xs"
	PUTBACK;
	_watcher_callback(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1310 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_cbtime); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_cbtime)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 704 "Event.xs"
	PUTBACK;
	_watcher_cbtime(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1332 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_desc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_desc)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 711 "Event.xs"
	PUTBACK;
	_watcher_desc(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1354 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_debug); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_debug)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 718 "Event.xs"
	PUTBACK;
	_watcher_debug(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1376 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_prio); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_prio)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 725 "Event.xs"
	PUTBACK;
	_watcher_priority(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1398 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_reentrant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_reentrant)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 732 "Event.xs"
	PUTBACK;
	_watcher_reentrant(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1420 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_repeat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_repeat)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 739 "Event.xs"
	PUTBACK;
	_watcher_repeat(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1442 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_max_cb_tm); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_max_cb_tm)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 746 "Event.xs"
	PUTBACK;
	_watcher_max_cb_tm(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1464 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher__Tied_allocate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher__Tied_allocate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "clname, temple");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0)
;
	SV *	temple = ST(1)
;
#line 757 "Event.xs"
	if (!SvROK(temple)) croak("Bad template");
	XPUSHs(watcher_2sv(pe_tied_allocate(gv_stashsv(clname, 1),
					    SvRV(temple))));
#line 1488 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher__Tied_hard); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher__Tied_hard)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 764 "Event.xs"
	PUTBACK;
	_timeable_hard(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1510 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher__Tied_at); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher__Tied_at)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 771 "Event.xs"
	PUTBACK;
	_tied_at(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1532 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher__Tied_flags); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher__Tied_flags)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 778 "Event.xs"
	PUTBACK;
	_tied_flags(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1554 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__idle_allocate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__idle_allocate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "clname, temple");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0)
;
	SV *	temple = ST(1)
;
#line 789 "Event.xs"
	if (!SvROK(temple)) croak("Bad template");
	XPUSHs(watcher_2sv(pe_idle_allocate(gv_stashsv(clname, 1),
			SvRV(temple))));
#line 1578 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__idle_hard); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__idle_hard)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 796 "Event.xs"
	PUTBACK;
	_timeable_hard(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1600 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__idle_max); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__idle_max)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 803 "Event.xs"
	PUTBACK;
	_idle_max_interval(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1622 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__idle_min); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__idle_min)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 810 "Event.xs"
	PUTBACK;
	_idle_min_interval(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1644 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__timer_allocate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__timer_allocate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "clname, temple");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0)
;
	SV *	temple = ST(1)
;
#line 821 "Event.xs"
	XPUSHs(watcher_2sv(pe_timer_allocate(gv_stashsv(clname, 1),
			SvRV(temple))));
#line 1667 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__timer_at); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__timer_at)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 827 "Event.xs"
	PUTBACK;
	_timer_at(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1689 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__timer_hard); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__timer_hard)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 834 "Event.xs"
	PUTBACK;
	_timeable_hard(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1711 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__timer_interval); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__timer_interval)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 841 "Event.xs"
	PUTBACK;
	_timer_interval(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1733 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__io_allocate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__io_allocate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "clname, temple");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0)
;
	SV *	temple = ST(1)
;
#line 852 "Event.xs"
	if (!SvROK(temple)) croak("Bad template");
	XPUSHs(watcher_2sv(pe_io_allocate(gv_stashsv(clname, 1),
			SvRV(temple))));
#line 1757 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__io_poll); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__io_poll)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 859 "Event.xs"
	PUTBACK;
	_io_poll(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1779 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__io_fd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__io_fd)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 866 "Event.xs"
	PUTBACK;
	_io_handle(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1801 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__io_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__io_timeout)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 873 "Event.xs"
	PUTBACK;
	_io_timeout(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1823 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__io_timeout_cb); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__io_timeout_cb)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 880 "Event.xs"
	PUTBACK;
	_io_timeout_cb(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1845 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__var_allocate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__var_allocate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "clname, temple");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0)
;
	SV *	temple = ST(1)
;
#line 891 "Event.xs"
	XPUSHs(watcher_2sv(pe_var_allocate(gv_stashsv(clname, 1),
		SvRV(temple))));
#line 1868 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__var_var); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__var_var)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 897 "Event.xs"
	PUTBACK;
	_var_variable(THIS, items == 2? ST(1) : 0); /* don't mortalcopy!! */
	SPAGAIN;
#line 1890 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__var_poll); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__var_poll)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 904 "Event.xs"
	PUTBACK;
	_var_events(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1912 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__signal_allocate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__signal_allocate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "clname, temple");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0)
;
	SV *	temple = ST(1)
;
#line 915 "Event.xs"
	XPUSHs(watcher_2sv(pe_signal_allocate(gv_stashsv(clname, 1),
		SvRV(temple))));
#line 1935 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__signal_signal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__signal_signal)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 921 "Event.xs"
	PUTBACK;
	_signal_signal(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1957 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__group_allocate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__group_allocate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "clname, temple");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0)
;
	SV *	temple = ST(1)
;
#line 932 "Event.xs"
     XPUSHs(watcher_2sv(pe_group_allocate(gv_stashsv(clname, 1),
		SvRV(temple))));
#line 1980 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__group_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__group_timeout)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 938 "Event.xs"
	PUTBACK;
	_group_timeout(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 2002 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__group_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__group_add)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 945 "Event.xs"
	PUTBACK;
	_group_add(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 2024 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__group_del); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__group_del)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 952 "Event.xs"
	PUTBACK;
	_group_del(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 2046 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__generic_allocate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__generic_allocate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "clname, temple");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0)
;
	SV *	temple = ST(1)
;
#line 963 "Event.xs"
     XPUSHs(watcher_2sv(pe_generic_allocate(gv_stashsv(clname, 1),
		SvRV(temple))));
#line 2069 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__generic_source); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__generic_source)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 969 "Event.xs"
	PUTBACK;
	_generic_source(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 2091 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__generic__Source_allocate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__generic__Source_allocate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "clname, temple");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0)
;
	SV *	temple = ST(1)
;
#line 980 "Event.xs"
	if (!SvROK(temple)) croak("Bad template");
	XPUSHs(genericsrc_2sv(pe_genericsrc_allocate(gv_stashsv(clname, 1),
			SvRV(temple))));
#line 2115 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__generic__Source_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__generic__Source_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ref");
    {
	SV *	ref = ST(0)
;
#line 988 "Event.xs"
{
	pe_genericsrc_dtor(sv_2genericsrc(ref));
}
#line 2135 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__generic__Source_event); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__generic__Source_event)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_genericsrc *	THIS = (pe_genericsrc *) sv_2genericsrc(ST(0))
;
#line 995 "Event.xs"
	pe_genericsrc_event(THIS,
		items >= 2 ? sv_mortalcopy(ST(1)) : &PL_sv_undef);
#line 2155 "Event.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Event); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Event)
{
    dVAR; dXSARGS;
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK;

        newXS("Event::_add_hook", XS_Event__add_hook, file);
        newXS("Event::_timeout_too_early", XS_Event__timeout_too_early, file);
        newXS("Event::_memory_counters", XS_Event__memory_counters, file);
        newXS("Event::_incr_looplevel", XS_Event__incr_looplevel, file);
        newXS("Event::_decr_looplevel", XS_Event__decr_looplevel, file);
        newXS("Event::unloop", XS_Event_unloop, file);
        newXS("Event::unloop_all", XS_Event_unloop_all, file);
        newXS("Event::cache_time_api", XS_Event_cache_time_api, file);
        (void)newXSproto_portable("Event::time", XS_Event_time, file, "");
        (void)newXSproto_portable("Event::sleep", XS_Event_sleep, file, "$");
        newXS("Event::null_loops_per_second", XS_Event_null_loops_per_second, file);
        (void)newXSproto_portable("Event::all_watchers", XS_Event_all_watchers, file, "");
        (void)newXSproto_portable("Event::all_idle", XS_Event_all_idle, file, "");
        (void)newXSproto_portable("Event::all_running", XS_Event_all_running, file, "");
        (void)newXSproto_portable("Event::queue", XS_Event_queue, file, "$;$");
        (void)newXSproto_portable("Event::one_event", XS_Event_one_event, file, ";$");
        newXS("Event::_loop", XS_Event__loop, file);
        newXS("Event::queue_pending", XS_Event_queue_pending, file);
        newXS("Event::_empty_queue", XS_Event__empty_queue, file);
        newXS("Event::queue_time", XS_Event_queue_time, file);
        newXS("Event::Event::Io::got", XS_Event__Event__Io_got, file);
        newXS("Event::Event::Dataful::data", XS_Event__Event__Dataful_data, file);
        newXS("Event::Event::DESTROY", XS_Event__Event_DESTROY, file);
        newXS("Event::Event::mom", XS_Event__Event_mom, file);
        newXS("Event::Event::w", XS_Event__Event_w, file);
        newXS("Event::Event::hits", XS_Event__Event_hits, file);
        newXS("Event::Event::prio", XS_Event__Event_prio, file);
        newXS("Event::Watcher::DESTROY", XS_Event__Watcher_DESTROY, file);
        newXS("Event::Watcher::pending", XS_Event__Watcher_pending, file);
        newXS("Event::Watcher::again", XS_Event__Watcher_again, file);
        newXS("Event::Watcher::start", XS_Event__Watcher_start, file);
        newXS("Event::Watcher::suspend", XS_Event__Watcher_suspend, file);
        newXS("Event::Watcher::resume", XS_Event__Watcher_resume, file);
        newXS("Event::Watcher::stop", XS_Event__Watcher_stop, file);
        newXS("Event::Watcher::cancel", XS_Event__Watcher_cancel, file);
        newXS("Event::Watcher::now", XS_Event__Watcher_now, file);
        newXS("Event::Watcher::use_keys", XS_Event__Watcher_use_keys, file);
        newXS("Event::Watcher::is_running", XS_Event__Watcher_is_running, file);
        newXS("Event::Watcher::is_active", XS_Event__Watcher_is_active, file);
        newXS("Event::Watcher::is_suspended", XS_Event__Watcher_is_suspended, file);
        newXS("Event::Watcher::is_cancelled", XS_Event__Watcher_is_cancelled, file);
        newXS("Event::Watcher::cb", XS_Event__Watcher_cb, file);
        newXS("Event::Watcher::cbtime", XS_Event__Watcher_cbtime, file);
        newXS("Event::Watcher::desc", XS_Event__Watcher_desc, file);
        newXS("Event::Watcher::debug", XS_Event__Watcher_debug, file);
        newXS("Event::Watcher::prio", XS_Event__Watcher_prio, file);
        newXS("Event::Watcher::reentrant", XS_Event__Watcher_reentrant, file);
        newXS("Event::Watcher::repeat", XS_Event__Watcher_repeat, file);
        newXS("Event::Watcher::max_cb_tm", XS_Event__Watcher_max_cb_tm, file);
        newXS("Event::Watcher::Tied::allocate", XS_Event__Watcher__Tied_allocate, file);
        newXS("Event::Watcher::Tied::hard", XS_Event__Watcher__Tied_hard, file);
        newXS("Event::Watcher::Tied::at", XS_Event__Watcher__Tied_at, file);
        newXS("Event::Watcher::Tied::flags", XS_Event__Watcher__Tied_flags, file);
        newXS("Event::idle::allocate", XS_Event__idle_allocate, file);
        newXS("Event::idle::hard", XS_Event__idle_hard, file);
        newXS("Event::idle::max", XS_Event__idle_max, file);
        newXS("Event::idle::min", XS_Event__idle_min, file);
        newXS("Event::timer::allocate", XS_Event__timer_allocate, file);
        newXS("Event::timer::at", XS_Event__timer_at, file);
        newXS("Event::timer::hard", XS_Event__timer_hard, file);
        newXS("Event::timer::interval", XS_Event__timer_interval, file);
        newXS("Event::io::allocate", XS_Event__io_allocate, file);
        newXS("Event::io::poll", XS_Event__io_poll, file);
        newXS("Event::io::fd", XS_Event__io_fd, file);
        newXS("Event::io::timeout", XS_Event__io_timeout, file);
        newXS("Event::io::timeout_cb", XS_Event__io_timeout_cb, file);
        newXS("Event::var::allocate", XS_Event__var_allocate, file);
        newXS("Event::var::var", XS_Event__var_var, file);
        newXS("Event::var::poll", XS_Event__var_poll, file);
        newXS("Event::signal::allocate", XS_Event__signal_allocate, file);
        newXS("Event::signal::signal", XS_Event__signal_signal, file);
        newXS("Event::group::allocate", XS_Event__group_allocate, file);
        newXS("Event::group::timeout", XS_Event__group_timeout, file);
        newXS("Event::group::add", XS_Event__group_add, file);
        newXS("Event::group::del", XS_Event__group_del, file);
        newXS("Event::generic::allocate", XS_Event__generic_allocate, file);
        newXS("Event::generic::source", XS_Event__generic_source, file);
        newXS("Event::generic::Source::allocate", XS_Event__generic__Source_allocate, file);
        newXS("Event::generic::Source::DESTROY", XS_Event__generic__Source_DESTROY, file);
        newXS("Event::generic::Source::event", XS_Event__generic__Source_event, file);

    /* Initialisation Section */

#line 288 "Event.xs"
  LoopLevel = ExitLevel = 0;
  DebugLevel = SvREFCNT_inc(perl_get_sv("Event::DebugLevel", 1));
  Eval = SvREFCNT_inc(perl_get_sv("Event::Eval", 1));
  Estat.on=0;
  boot_timeable();
  boot_hook();
  boot_pe_event();
  boot_pe_watcher();
  boot_idle();
  boot_timer();
  boot_io();
  boot_devpoll();
  boot_var();
  boot_tied();
  boot_signal();
  boot_group();
  boot_generic();
  boot_queue();
  {
      SV *apisv;
      api.Ver = EventAPI_VERSION;
      api.start = pe_watcher_start;
      api.queue = queueEvent;
      api.now = pe_watcher_now;
      api.suspend = pe_watcher_suspend;
      api.resume = pe_watcher_resume;
      api.stop = pe_watcher_stop;
      api.cancel = pe_watcher_cancel;
      api.tstart = pe_timeable_start;
      api.tstop  = pe_timeable_stop;
      api.NVtime = fallback_NVtime;
      api.new_idle =   (pe_idle*  (*)(HV*,SV*))    pe_idle_allocate;
      api.new_timer =  (pe_timer* (*)(HV*,SV*))    pe_timer_allocate;
      api.new_io =     (pe_io*    (*)(HV*,SV*))    pe_io_allocate;
      api.new_var =    (pe_var*   (*)(HV*,SV*))    pe_var_allocate;
      api.new_signal = (pe_signal*(*)(HV*,SV*))    pe_signal_allocate;
      api.add_hook = capi_add_hook;
      api.cancel_hook = pe_cancel_hook;
      api.install_stats = pe_install_stats;
      api.collect_stats = pe_collect_stats;
      api.AllWatchers = &AllWatchers;
      api.watcher_2sv = watcher_2sv;
      api.sv_2watcher = sv_2watcher;
      api.event_2sv = event_2sv;
      api.sv_2event = sv_2event;
      api.unloop = pe_unloop;
      api.unloop_all = pe_unloop_all;
      api.sv_2interval = sv_2interval;
      api.events_mask_2sv = events_mask_2sv;
      api.sv_2events_mask = sv_2events_mask;

      apisv = perl_get_sv("Event::API", 1);
      sv_setiv(apisv, (IV)&api);
      SvREADONLY_on(apisv);
  }

#line 2321 "Event.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

